# coding: utf-8

"""
    Onshape REST API

    The Onshape REST API consumed by all clients.  # noqa: E501

    The version of the OpenAPI document: 1.106
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class BTMAssemblyFeature(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'occurrence_queries_from_all_configurations': 'list[BTMIndividualQueryWithOccurrenceBase]',
        'feature_list_field_index': 'int',
        'auxiliary_assembly_feature': 'bool',
        'version': 'int'
    }

    attribute_map = {
        'occurrence_queries_from_all_configurations': 'occurrenceQueriesFromAllConfigurations',
        'feature_list_field_index': 'featureListFieldIndex',
        'auxiliary_assembly_feature': 'auxiliaryAssemblyFeature',
        'version': 'version'
    }

    discriminator_value_class_map = {
        'BTExplosion': 'BTExplosion',
        'BTMAssemblyFeature2': 'BTMAssemblyFeature2',
        'BTMAssemblyFeature1': 'BTMAssemblyFeature1',
        'BTMMateConnector': 'BTMMateConnector',
        'BTMMateGroup': 'BTMMateGroup',
        'BTMMate': 'BTMMate',
        'BTMAssemblyPatternFeature': 'BTMAssemblyPatternFeature',
        'BTMNonGeometricItem': 'BTMNonGeometricItem',
        'BTExplosionStepFeature': 'BTExplosionStepFeature',
        'BTMMateRelation': 'BTMMateRelation',
        'BTMGeometryMate': 'BTMGeometryMate'
    }

    def __init__(self, occurrence_queries_from_all_configurations=None, feature_list_field_index=None, auxiliary_assembly_feature=None, version=None):  # noqa: E501
        """BTMAssemblyFeature - a model defined in OpenAPI"""  # noqa: E501

        self._occurrence_queries_from_all_configurations = None
        self._feature_list_field_index = None
        self._auxiliary_assembly_feature = None
        self._version = None
        self.discriminator = 'bt_type'

        if occurrence_queries_from_all_configurations is not None:
            self.occurrence_queries_from_all_configurations = occurrence_queries_from_all_configurations
        if feature_list_field_index is not None:
            self.feature_list_field_index = feature_list_field_index
        if auxiliary_assembly_feature is not None:
            self.auxiliary_assembly_feature = auxiliary_assembly_feature
        if version is not None:
            self.version = version

    @property
    def occurrence_queries_from_all_configurations(self):
        """Gets the occurrence_queries_from_all_configurations of this BTMAssemblyFeature.  # noqa: E501


        :return: The occurrence_queries_from_all_configurations of this BTMAssemblyFeature.  # noqa: E501
        :rtype: list[BTMIndividualQueryWithOccurrenceBase]
        """
        return self._occurrence_queries_from_all_configurations

    @occurrence_queries_from_all_configurations.setter
    def occurrence_queries_from_all_configurations(self, occurrence_queries_from_all_configurations):
        """Sets the occurrence_queries_from_all_configurations of this BTMAssemblyFeature.


        :param occurrence_queries_from_all_configurations: The occurrence_queries_from_all_configurations of this BTMAssemblyFeature.  # noqa: E501
        :type: list[BTMIndividualQueryWithOccurrenceBase]
        """

        self._occurrence_queries_from_all_configurations = occurrence_queries_from_all_configurations

    @property
    def feature_list_field_index(self):
        """Gets the feature_list_field_index of this BTMAssemblyFeature.  # noqa: E501


        :return: The feature_list_field_index of this BTMAssemblyFeature.  # noqa: E501
        :rtype: int
        """
        return self._feature_list_field_index

    @feature_list_field_index.setter
    def feature_list_field_index(self, feature_list_field_index):
        """Sets the feature_list_field_index of this BTMAssemblyFeature.


        :param feature_list_field_index: The feature_list_field_index of this BTMAssemblyFeature.  # noqa: E501
        :type: int
        """

        self._feature_list_field_index = feature_list_field_index

    @property
    def auxiliary_assembly_feature(self):
        """Gets the auxiliary_assembly_feature of this BTMAssemblyFeature.  # noqa: E501


        :return: The auxiliary_assembly_feature of this BTMAssemblyFeature.  # noqa: E501
        :rtype: bool
        """
        return self._auxiliary_assembly_feature

    @auxiliary_assembly_feature.setter
    def auxiliary_assembly_feature(self, auxiliary_assembly_feature):
        """Sets the auxiliary_assembly_feature of this BTMAssemblyFeature.


        :param auxiliary_assembly_feature: The auxiliary_assembly_feature of this BTMAssemblyFeature.  # noqa: E501
        :type: bool
        """

        self._auxiliary_assembly_feature = auxiliary_assembly_feature

    @property
    def version(self):
        """Gets the version of this BTMAssemblyFeature.  # noqa: E501


        :return: The version of this BTMAssemblyFeature.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this BTMAssemblyFeature.


        :param version: The version of this BTMAssemblyFeature.  # noqa: E501
        :type: int
        """

        self._version = version

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_key = self.attribute_map[self.discriminator]
        discriminator_value = data[discriminator_key]
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BTMAssemblyFeature):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
